//////////////////////////////////////////////////////////////////////////////
// SAMPLE: CorBrowser, display all managed processes on the system
//
// Copyright (c) 2002 Vadim Melnik (vmelnik@docsultant.com). 
// All rights reserved.
//
// http://www.docsultant.com/
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;

namespace Docsultant.Samples.Interop.CorBrowser
{
	/// <summary>
	/// About dialog form
	/// </summary>
	public class AboutDlg : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button buttonOK;
		private System.Windows.Forms.PictureBox pictureBoxIcon;
		private System.Windows.Forms.LinkLabel linkLabelHomapage;
		private System.Windows.Forms.LinkLabel linkLabelMail;
		private System.Windows.Forms.GroupBox groupBox;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public AboutDlg()
		{
			InitializeComponent();
			linkLabelMail.Links.Add(49, 12, "mailto:vmelnik@docsultant.com");
			String sURL = "http://www.docsultant.com/";
			linkLabelHomapage.Links.Add(0, sURL.Length, sURL);
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutDlg));
			this.buttonOK = new System.Windows.Forms.Button();
			this.pictureBoxIcon = new System.Windows.Forms.PictureBox();
			this.linkLabelHomapage = new System.Windows.Forms.LinkLabel();
			this.linkLabelMail = new System.Windows.Forms.LinkLabel();
			this.groupBox = new System.Windows.Forms.GroupBox();
			this.SuspendLayout();
			// 
			// buttonOK
			// 
			this.buttonOK.Location = new System.Drawing.Point(96, 112);
			this.buttonOK.Name = "buttonOK";
			this.buttonOK.TabIndex = 0;
			this.buttonOK.Text = "OK";
			this.buttonOK.Click += new System.EventHandler(this.button1_Click);
			// 
			// pictureBoxIcon
			// 
			this.pictureBoxIcon.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBoxIcon.Image")));
			this.pictureBoxIcon.Location = new System.Drawing.Point(24, 24);
			this.pictureBoxIcon.Name = "pictureBoxIcon";
			this.pictureBoxIcon.Size = new System.Drawing.Size(16, 16);
			this.pictureBoxIcon.TabIndex = 2;
			this.pictureBoxIcon.TabStop = false;
			// 
			// linkLabelHomapage
			// 
			this.linkLabelHomapage.Location = new System.Drawing.Point(40, 64);
			this.linkLabelHomapage.Name = "linkLabelHomapage";
			this.linkLabelHomapage.Size = new System.Drawing.Size(184, 23);
			this.linkLabelHomapage.TabIndex = 3;
			this.linkLabelHomapage.TabStop = true;
			this.linkLabelHomapage.Text = "http://www.docsultant.com/";
			this.linkLabelHomapage.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabelHomapage.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelHomapage_LinkClicked);
			// 
			// linkLabelMail
			// 
			this.linkLabelMail.Location = new System.Drawing.Point(40, 16);
			this.linkLabelMail.Name = "linkLabelMail";
			this.linkLabelMail.Size = new System.Drawing.Size(184, 48);
			this.linkLabelMail.TabIndex = 4;
			this.linkLabelMail.TabStop = true;
			this.linkLabelMail.Text = "CorBrowser, Version 1.0,   Copyright 2002 (c) by Vadim Melnik";
			this.linkLabelMail.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabelMail.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabelMail_LinkClicked);
			// 
			// groupBox
			// 
			this.groupBox.Location = new System.Drawing.Point(16, 8);
			this.groupBox.Name = "groupBox";
			this.groupBox.Size = new System.Drawing.Size(216, 88);
			this.groupBox.TabIndex = 5;
			this.groupBox.TabStop = false;
			// 
			// AboutDlg
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(248, 146);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.linkLabelMail,
																																	this.linkLabelHomapage,
																																	this.pictureBoxIcon,
																																	this.buttonOK,
																																	this.groupBox});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AboutDlg";
			this.ShowInTaskbar = false;
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.Text = "About CorBrowser Dialog";
			this.TopMost = true;
			this.ResumeLayout(false);

		}
		#endregion

		private void button1_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void linkLabelHomapage_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Process.Start(e.Link.LinkData.ToString());
		}

		private void linkLabelMail_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Process.Start(e.Link.LinkData.ToString());
		}
	}
}
