//////////////////////////////////////////////////////////////////////////////
// SAMPLE: CorBrowser, display all managed processes on the system
//
// Copyright (c) 2002 Vadim Melnik (vmelnik@docsultant.com). 
// All rights reserved.
//
// http://www.docsultant.com/
//

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using CorpubProcessLib;
//
using CORDBLib;
using System.Diagnostics;
using System.Threading;
using System.Reflection;
using System.Runtime.Remoting.Contexts;


namespace Docsultant.Samples.Interop.CorBrowser
{
	/// <summary>
	/// MainFrame - CorBrowser main window form.
	/// </summary>
	public class MainFrame : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TreeView treeProc;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem menuItemFileExit;
		private System.Windows.Forms.MenuItem menuItemHelpAbout;
		private System.Windows.Forms.MenuItem menuItemRefresh;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItemExpandAll;
		private System.Windows.Forms.MenuItem menuItemCollapseAll;
		private System.Windows.Forms.ImageList imgIcons;
		private System.Windows.Forms.ContextMenu contextMenuProc;
		private System.Windows.Forms.MenuItem menuItemProcKill;
		private System.Windows.Forms.MenuItem menuItemProcClose;
		private System.ComponentModel.IContainer components;

		public MainFrame()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			BuildTree();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainFrame));
			this.treeProc = new System.Windows.Forms.TreeView();
			this.contextMenuProc = new System.Windows.Forms.ContextMenu();
			this.menuItemProcKill = new System.Windows.Forms.MenuItem();
			this.menuItemProcClose = new System.Windows.Forms.MenuItem();
			this.imgIcons = new System.Windows.Forms.ImageList(this.components);
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.menuItemFile = new System.Windows.Forms.MenuItem();
			this.menuItemFileExit = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItemExpandAll = new System.Windows.Forms.MenuItem();
			this.menuItemCollapseAll = new System.Windows.Forms.MenuItem();
			this.menuItemRefresh = new System.Windows.Forms.MenuItem();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemHelpAbout = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// treeProc
			// 
			this.treeProc.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.treeProc.ContextMenu = this.contextMenuProc;
			this.treeProc.ImageList = this.imgIcons;
			this.treeProc.Indent = 19;
			this.treeProc.Name = "treeProc";
			this.treeProc.Size = new System.Drawing.Size(320, 387);
			this.treeProc.TabIndex = 0;
			this.treeProc.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeProc_AfterSelect);
			// 
			// contextMenuProc
			// 
			this.contextMenuProc.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																										this.menuItemProcKill,
																																										this.menuItemProcClose});
			// 
			// menuItemProcKill
			// 
			this.menuItemProcKill.Index = 0;
			this.menuItemProcKill.Text = "&Kill";
			this.menuItemProcKill.Click += new System.EventHandler(this.menuItemProcKill_Click);
			// 
			// menuItemProcClose
			// 
			this.menuItemProcClose.Index = 1;
			this.menuItemProcClose.Text = "&Close";
			this.menuItemProcClose.Click += new System.EventHandler(this.menuItemProcClose_Click);
			// 
			// imgIcons
			// 
			this.imgIcons.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgIcons.ImageSize = new System.Drawing.Size(16, 16);
			this.imgIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgIcons.ImageStream")));
			this.imgIcons.TransparentColor = System.Drawing.Color.White;
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																						 this.menuItemFile,
																																						 this.menuItem1,
																																						 this.menuItemHelp});
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								 this.menuItemFileExit});
			this.menuItemFile.Text = "&File";
			// 
			// menuItemFileExit
			// 
			this.menuItemFileExit.Index = 0;
			this.menuItemFileExit.Text = "E&xit";
			this.menuItemFileExit.Click += new System.EventHandler(this.menuItemFileExit_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																							this.menuItemExpandAll,
																																							this.menuItemCollapseAll,
																																							this.menuItemRefresh});
			this.menuItem1.Text = "&View";
			// 
			// menuItemExpandAll
			// 
			this.menuItemExpandAll.Index = 0;
			this.menuItemExpandAll.Text = "&Expand All";
			this.menuItemExpandAll.Click += new System.EventHandler(this.menuItemExpandAll_Click);
			// 
			// menuItemCollapseAll
			// 
			this.menuItemCollapseAll.Index = 1;
			this.menuItemCollapseAll.Text = "Collapse All";
			this.menuItemCollapseAll.Click += new System.EventHandler(this.menuItemCollapseAll_Click);
			// 
			// menuItemRefresh
			// 
			this.menuItemRefresh.Index = 2;
			this.menuItemRefresh.Shortcut = System.Windows.Forms.Shortcut.F5;
			this.menuItemRefresh.Text = "&Refresh";
			this.menuItemRefresh.Click += new System.EventHandler(this.menuItemRefresh_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 2;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																																								 this.menuItemHelpAbout});
			this.menuItemHelp.Text = "&Help";
			// 
			// menuItemHelpAbout
			// 
			this.menuItemHelpAbout.Index = 0;
			this.menuItemHelpAbout.Text = "&About";
			this.menuItemHelpAbout.Click += new System.EventHandler(this.menuItemHelpAbout_Click);
			// 
			// MainFrame
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(320, 386);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.treeProc});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu;
			this.Name = "MainFrame";
			this.Text = "CorBrowser";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainFrame());
		}

		private void treeProc_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
		
		}

		private void menuItemHelpAbout_Click(object sender, System.EventArgs e)
		{
			AboutDlg dlg = new AboutDlg();
			dlg.ShowDialog(this);
		}

		private void menuItemFileExit_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void BuildTree()
		{
			treeProc.BeginUpdate();
			treeProc.Nodes.Clear();
			CorPubHelper.EnumManagedProcesses(new CorPubHelper.EnumProcessesProc(EnumProcessesProc), null);
			treeProc.EndUpdate();
		}

		private bool EnumProcessesProc(ICorPublishProcess proc, object param)
		{
			uint pid;
			proc.GetProcessID(out pid);

			string sPath = CorPubHelper.GetName(new CorPubHelper.GetNameDelegator(proc.GetDisplayName));

			int bManaged;
			proc.IsManaged(out bManaged);

			TreeNode node = new TreeNode(String.Format("Process, ID=0x{0:x8}, {1}, \"{2}\"", pid, bManaged==0?"unmanaged":"managed", sPath), 0, 0);
			node.Tag = proc;
			treeProc.Nodes.Add(node);
			CorPubHelper.EnumAppDomains(proc, new CorPubHelper.EnumAppDomainProc(EnumAppDomainProc), node);
			
			return true;
		}

		private bool EnumAppDomainProc(ICorPublishAppDomain domain, object param)
		{
			TreeNode node = (TreeNode)param;

			uint id;
			domain.GetID(out id);

			string sName = CorPubHelper.GetName(new CorPubHelper.GetNameDelegator(domain.GetName));
			node.Nodes.Add(new TreeNode(String.Format("AppDomain, ID=0x{0:x8}, \"{1}\"", id, sName), 1, 1));
			return true;
		}

		private void menuItemRefresh_Click(object sender, System.EventArgs e)
		{
			BuildTree();
		}

		private void menuItemExpandAll_Click(object sender, System.EventArgs e)
		{
			treeProc.ExpandAll();
		}

		private void menuItemCollapseAll_Click(object sender, System.EventArgs e)
		{
			treeProc.CollapseAll();
		}

		private bool getSelectedProcessId(out uint pid)
		{
			pid = 0;
			TreeNode node = treeProc.SelectedNode;
			if( node!=null && node.Tag is ICorPublishProcess )
			{
				ICorPublishProcess proc = (ICorPublishProcess )node.Tag;
				proc.GetProcessID(out pid);
				return true;
			}
			return false;
		}

		private void menuItemProcKill_Click(object sender, System.EventArgs e)
		{
			uint pid = 0;
			if( getSelectedProcessId(out pid) )
				Process.GetProcessById((int)pid).Kill();
		}

		private void menuItemProcClose_Click(object sender, System.EventArgs e)
		{
			uint pid = 0;
			if( getSelectedProcessId(out pid) )
				Process.GetProcessById((int)pid).CloseMainWindow();
		}

	}
}
